Index: trunk/src/world_entities/WorldEntities.am
===================================================================
--- trunk/src/world_entities/WorldEntities.am	(revision 9059)
+++ trunk/src/world_entities/WorldEntities.am	(revision 9061)
@@ -44,5 +44,7 @@
                 world_entities/space_ships/hover.cc \
                 world_entities/space_ships/turbine_hover.cc \
+                world_entities/space_ships/spacecraft_2d.cc \
                 world_entities/space_ships/collision_probe.cc \
+                world_entities/space_ships/cruizer.cc \
                 world_entities/creatures/md2_creature.cc \
                 world_entities/creatures/fps_player.cc \
@@ -107,5 +109,7 @@
                 space_ships/hover.h \
                 space_ships/turbine_hover.h \
-                space_ships/collision_probe.cc \
+                space_ships/spacecraft_2d.h \
+                space_ships/collision_probe.h \
+                space_ships/cruizer.h \
                 creatures/md2_creature.h \
                 creatures/fps_player.h \
Index: trunk/src/world_entities/npcs/generic_npc.cc
===================================================================
--- trunk/src/world_entities/npcs/generic_npc.cc	(revision 9059)
+++ trunk/src/world_entities/npcs/generic_npc.cc	(revision 9061)
@@ -40,4 +40,7 @@
                         ->addMethod("turnTo", ExecutorLua1<GenericNPC,float>(&GenericNPC::turnTo))
                         ->addMethod("finalGoalReached", ExecutorLua0ret<GenericNPC,bool>(&GenericNPC::finalGoalReached))
+                        ->addMethod("stop", ExecutorLua0<GenericNPC>(&GenericNPC::stop))
+                        ->addMethod("resume", ExecutorLua0<GenericNPC>(&GenericNPC::resume))
+                        ->addMethod("playAnimation", ExecutorLua2<GenericNPC,int,int>(&GenericNPC::playAnimation))
                         // Display
                         ->addMethod("hide", ExecutorLua0<WorldEntity>(&WorldEntity::hide))
@@ -49,5 +52,4 @@
                         ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
                         ->addMethod("setAbsDir", ExecutorLua4<PNode,float,float,float,float>(&PNode::setAbsDir))
-
                        );
 
@@ -88,4 +90,6 @@
   time = 30.0f;
 
+  this->behaviourList = new std::list<GenericNPC::Anim>;
+
   // collision reaction registration
 //   this->subscribeReaction(CREngine::CR_PHYSICS_GROUND_WALK, CL_BSP_ENTITY);
@@ -170,5 +174,5 @@
  * @param filename: name of the file
  */
-void GenericNPC::playSound(std::string filename)
+void GenericNPC::playSound(const std::string& filename)
 {}
 
@@ -179,18 +183,32 @@
  */
 void GenericNPC::stop()
-{}
-
-
-
+{
+  this->animationStack.push(this->behaviourList);
+  this->behaviourList = new std::list<GenericNPC::Anim>;
+}
+
+
+/**
+ * continue the generic animation
+ */
+void GenericNPC::resume()
+{
+  //if()
+  delete this->behaviourList;
+  this->behaviourList = this->animationStack.top();
+  this->animationStack.pop();
+}
+
+
+/**
+ * each animation has to be initialized here
+ */
 void GenericNPC::initNPC()
 {
-
-  this->unsubscribeReaction();
-
-  if (!this->behaviourList.empty())
-  {
-    GenericNPC::Anim currentAnimation = this->behaviourList.front();
-
-    switch(this->behaviourList.front().type)
+  if (!this->behaviourList->empty())
+  {
+    GenericNPC::Anim currentAnimation = this->behaviourList->front();
+
+    switch(this->behaviourList->front().type)
     {
       case Walk:
@@ -213,4 +231,6 @@
 
         Vector dir = (currentAnimation.v - this->getAbsCoor()).getNormalized();
+        dir.y = 0.0f;
+        dir.getNormalized();
         this->setAbsDir(Quaternion(dir, Vector(0.0, 1.0, 0.0)) * Quaternion(-M_PI_2, Vector(0.0, 1.0, 0.0)));
 
@@ -224,4 +244,6 @@
 
         Vector dir = (currentAnimation.v - this->getAbsCoor()).getNormalized();
+        dir.y = 0.0f;
+        dir.getNormalized();
         this->setAbsDir(Quaternion(dir, Vector(0.0, 1.0, 0.0)) * Quaternion(-M_PI_2, Vector(0.0, 1.0, 0.0)));
 
@@ -250,13 +272,13 @@
 void GenericNPC::nextStep()
 {
-  if (!this->behaviourList.empty())
-    this->behaviourList.pop_front();
+  if (!this->behaviourList->empty())
+    this->behaviourList->pop_front();
   else
     return;
 
 
-  if (!this->behaviourList.empty())
-  {
-    GenericNPC::Anim currentAnimation = this->behaviourList.front();
+  if (!this->behaviourList->empty())
+  {
+    GenericNPC::Anim currentAnimation = this->behaviourList->front();
 
     switch( currentAnimation.type)
@@ -266,4 +288,5 @@
         if( this->getAnimation() != RUN)
           this->setAnimation(RUN, MD2_ANIM_LOOP);
+
 
         Vector dir = (currentAnimation.v - this->getAbsCoor());
@@ -281,4 +304,6 @@
 
         Vector dir = (currentAnimation.v - this->getAbsCoor()).getNormalized();
+        dir.y = 0.0f;
+        dir.getNormalized();
         this->setAbsDirSoft(Quaternion(dir, Vector(0.0, 1.0, 0.0)) * Quaternion(-M_PI_2, Vector(0.0, 1.0, 0.0)), 4.0);
 
@@ -292,4 +317,6 @@
 
         Vector dir = (currentAnimation.v - this->getAbsCoor()).getNormalized();
+        dir.y = 0.0f;
+        dir.getNormalized();
         this->setAbsDirSoft(Quaternion(dir, Vector(0.0, 1.0, 0.0)) * Quaternion(-M_PI_2, Vector(0.0, 1.0, 0.0)), 4.0);
 
@@ -332,11 +359,11 @@
   anim.speed = 30.0f;
 
-  if( this->behaviourList.empty())
-  {
-    this->behaviourList.push_back(anim);
+  if( this->behaviourList->empty())
+  {
+    this->behaviourList->push_back(anim);
     this->initNPC();
   }
   else
-    this->behaviourList.push_back(anim);
+    this->behaviourList->push_back(anim);
 }
 
@@ -356,11 +383,11 @@
   anim.speed = 60.0f;
 
-  if( this->behaviourList.empty())
-  {
-    this->behaviourList.push_back(anim);
+  if( this->behaviourList->empty())
+  {
+    this->behaviourList->push_back(anim);
     this->initNPC();
   }
   else
-    this->behaviourList.push_back(anim);
+    this->behaviourList->push_back(anim);
 }
 
@@ -377,11 +404,11 @@
   anim.type = Crouch;
 
-  if( this->behaviourList.empty())
-  {
-    this->behaviourList.push_back(anim);
+  if( this->behaviourList->empty())
+  {
+    this->behaviourList->push_back(anim);
     this->initNPC();
   }
   else
-    this->behaviourList.push_back(anim);
+    this->behaviourList->push_back(anim);
 }
 void GenericNPC::crouchTo(float x, float y, float z)
@@ -398,11 +425,11 @@
   anim.type = TurnTo;
 
-  if( this->behaviourList.empty())
-  {
-    this->behaviourList.push_back(anim);
+  if( this->behaviourList->empty())
+  {
+    this->behaviourList->push_back(anim);
     this->initNPC();
   }
   else
-    this->behaviourList.push_back(anim);
+    this->behaviourList->push_back(anim);
 }
 
@@ -419,11 +446,11 @@
   anim.type = LookAt;
 
-  if( this->behaviourList.empty())
-  {
-    this->behaviourList.push_back(anim);
+  if( this->behaviourList->empty())
+  {
+    this->behaviourList->push_back(anim);
     this->initNPC();
   }
   else
-    this->behaviourList.push_back(anim);
+    this->behaviourList->push_back(anim);
 }
 
@@ -466,7 +493,7 @@
 
 
-  if (!this->behaviourList.empty())
-  {
-    GenericNPC::Anim currentAnimation = this->behaviourList.front();
+  if (!this->behaviourList->empty())
+  {
+    GenericNPC::Anim currentAnimation = this->behaviourList->front();
 
     switch( currentAnimation.type)
@@ -475,4 +502,5 @@
         {
           Vector dest = currentAnimation.v - this->getAbsCoor();
+          dest.y = 0.0f;
           if (dest.len() < .5)
           {
@@ -481,6 +509,6 @@
           else
           {
-            dest.y = 0.0f;
-            this->shiftCoor(dest.getNormalized() * currentAnimation.speed * dt);
+            Vector move = dest.getNormalized() * currentAnimation.speed * dt;
+            this->shiftCoor(move);
           }
         }
@@ -528,17 +556,16 @@
 
   // physical falling of the player
-//   if( !this->isOnGround())
-//   {
-//     this->fallVelocity += 300.0f * dt;
-//     velocity -= Vector(0.0, 1.0, 0.0) * this->fallVelocity;
-//    // PRINTF(0)("%s is not on ground\n", this->getName());
-//     this->shiftCoor(Vector(0, -this->fallVelocity * dt,0));
-//   }
-//   else
-//   {
-//     this->fallVelocity = 0.0f;
-//   }
-
-
+  if( !this->isOnGround())
+  {
+    this->fallVelocity += 300.0f * dt;
+    //velocity -= Vector(0.0, 1.0, 0.0) * this->fallVelocity;
+   // PRINTF(0)("%s is not on ground\n", this->getName());
+    this->shiftCoor(Vector(0, -this->fallVelocity * dt,0));
+
+  }
+  else
+  {
+    this->fallVelocity = 0.0f;
+  }
 
 }
Index: trunk/src/world_entities/npcs/generic_npc.h
===================================================================
--- trunk/src/world_entities/npcs/generic_npc.h	(revision 9059)
+++ trunk/src/world_entities/npcs/generic_npc.h	(revision 9061)
@@ -12,4 +12,7 @@
 
 #include "sound_source.h"
+
+#include <stack>
+
 
 namespace OrxSound{ class SoundSource; }
@@ -35,5 +38,5 @@
 
 
-  bool finalGoalReached() { return this->behaviourList.empty(); };
+  bool finalGoalReached() { return this->behaviourList->empty(); };
 
   /* npc controlling functions to be Queued */
@@ -52,4 +55,5 @@
   /* stopping the movement */
   void stop();
+  void resume();
   void nextStep();
 
@@ -68,6 +72,5 @@
   /* some generic control funtions */
   void playAnimation(int animationIndex, int animPlaybackMode);
-  void playSound(std::string filename);
-  void playSound(int i);
+  void playSound(const std::string& filename);
 
   virtual void tick (float time);
@@ -123,5 +126,6 @@
    float                                   soundVolume;
 
-   std::list<GenericNPC::Anim>             behaviourList;
+   std::list<GenericNPC::Anim>*            behaviourList;
+   std::stack<std::list<GenericNPC::Anim>*> animationStack;
    Vector                                  destCoor;
    Quaternion                              destDir;
Index: trunk/src/world_entities/playable.cc
===================================================================
--- trunk/src/world_entities/playable.cc	(revision 9059)
+++ trunk/src/world_entities/playable.cc	(revision 9061)
@@ -63,4 +63,5 @@
   this->score = 0;
   this->collider = NULL;
+  this->enterRadius = 10.0f;
 
   this->bDead = false;
@@ -94,4 +95,6 @@
 
   LoadParam(root, "abs-dir", this, Playable, setPlayDirection);
+  LoadParam(root, "enter-radius", this, Playable, setEnterRadius)
+      .describe("The Distance one can enter the ship from.");
 }
 
Index: trunk/src/world_entities/playable.h
===================================================================
--- trunk/src/world_entities/playable.h	(revision 9059)
+++ trunk/src/world_entities/playable.h	(revision 9061)
@@ -56,4 +56,5 @@
 
   // Player Settup
+  bool hasPlayer(){return !(this->currentPlayer == NULL);}
   bool setPlayer(Player* player);
   Player* getCurrentPlayer() const { return this->currentPlayer; };
@@ -74,4 +75,7 @@
   inline int  getScore() { return this->score; }
 
+  void setEnterRadius(float radius) { this->enterRadius = radius; };
+  /** @returns the EnterRadius (how far away a Player must be to enter this entity) */
+  inline float getEnterRadius() const { return this->enterRadius; };
 
   // WorldEntity Extensions
@@ -116,4 +120,6 @@
   Playable::Playmode    playmode;           //!< The current playmode.
 
+  float                 enterRadius;        //!< How far one can be away from the Playable to enter it.
+
   WorldEntity* collider;
 };
Index: trunk/src/world_entities/player.cc
===================================================================
--- trunk/src/world_entities/player.cc	(revision 9059)
+++ trunk/src/world_entities/player.cc	(revision 9061)
@@ -32,5 +32,5 @@
 Player::Player()
 {
-//  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
+  //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
   this->setClassID(CL_PLAYER, "Player");
 
@@ -74,10 +74,10 @@
   {
     PRINTF(4)("Enter new Playable\n");
-      this->playable = playable;
-      this->_hud.setEnergyWidget(this->playable->getHealthWidget());
-      this->_hud.setWeaponManager(&this->playable->getWeaponManager());
+    this->playable = playable;
+    this->hud.setEnergyWidget(this->playable->getHealthWidget());
+    this->hud.setWeaponManager(&this->playable->getWeaponManager());
 
-      this->playable->setPlayer(this);
-      return true;
+    this->playable->setPlayer(this);
+    return true;
   }
 
@@ -89,7 +89,7 @@
 
 bool Player::eject()
- {
-   return this->setPlayable(NULL);
- }
+{
+  return this->setPlayable(NULL);
+}
 
 
@@ -99,26 +99,34 @@
  }
 
- void Player::process(const Event &event)
- {
-   if (event.type == KeyMapper::PEV_CHANGE_SHIP && event.bPressed)
-   {
-     /// FIXME this should be in the ObjectManager
-     const std::list<BaseObject*>* objectList = ClassList::getList(CL_PLAYABLE);
-     if (objectList != NULL)
-     {
-       std::list<BaseObject*>::const_iterator node;
-       for (node = objectList->begin(); node != objectList->end(); node++)
-         if (this->playable != (*node) && (dynamic_cast<PNode*>(*node)->getAbsCoor() - this->playable->getAbsCoor()).len() < 10.0)
-       {
 
-         this->setPlayable(dynamic_cast<Playable*>(*node));
+void Player::enterNewPlayable()
+{
+  /// FIXME this should be in the ObjectManager
+  const std::list<BaseObject*>* objectList = ClassList::getList(CL_PLAYABLE);
+  if (objectList != NULL)
+  {
+    std::list<BaseObject*>::const_iterator node;
+    for (node = objectList->begin(); node != objectList->end(); node++)
+      if (this->playable != (*node) &&
+          (dynamic_cast<PNode*>(*node)->getAbsCoor() - this->playable->getAbsCoor()).len() < (dynamic_cast<Playable*>(*node)->getEnterRadius()))
+      {
 
-         break;
-       }
-     }
-   }
+        this->setPlayable(dynamic_cast<Playable*>(*node));
 
-   if (likely(this->playable != NULL))
-     this->playable->process(event);
- }
+        break;
+      }
+  }
+}
 
+
+void Player::process(const Event &event)
+{
+  if (event.type == KeyMapper::PEV_CHANGE_SHIP && event.bPressed)
+  {
+    this->enterNewPlayable();
+  }
+
+  if (likely(this->playable != NULL))
+    this->playable->process(event);
+}
+
Index: trunk/src/world_entities/player.h
===================================================================
--- trunk/src/world_entities/player.h	(revision 9059)
+++ trunk/src/world_entities/player.h	(revision 9061)
@@ -38,4 +38,5 @@
 
     void              weaponConfigChanged();
+    void              enterNewPlayable();
 
     // eventListener extension.
Index: trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- trunk/src/world_entities/projectiles/laser.cc	(revision 9059)
+++ trunk/src/world_entities/projectiles/laser.cc	(revision 9061)
@@ -140,8 +140,10 @@
 void Laser::draw () const
 {
-  glMatrixMode(GL_MODELVIEW);
-  glPushMatrix();
   glPushAttrib(GL_ENABLE_BIT);
   glDisable(GL_LIGHTING);
+
+  WorldEntity::draw();
+/*  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
 
   float matrix[4][4];
@@ -151,6 +153,7 @@
   glScalef(2.0, 2.0, 2.0);
   this->getModel()->draw();
+  glPopMatrix();*/
+
   glPopAttrib();
-  glPopMatrix();
 }
 
Index: trunk/src/world_entities/script_trigger.cc
===================================================================
--- trunk/src/world_entities/script_trigger.cc	(revision 9059)
+++ trunk/src/world_entities/script_trigger.cc	(revision 9061)
@@ -23,9 +23,20 @@
 
 CREATE_SCRIPTABLE_CLASS(ScriptTrigger, CL_SCRIPT_TRIGGER,
-                            addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                                ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                                ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                                ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
-                       );
+            // Coordinates
+             addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
+             ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
+             ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
+             ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+            //Properties
+             ->addMethod("setTarget", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setTarget))
+             ->addMethod("setTriggerParent", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setTriggerParent))
+             ->addMethod("setTriggerLasts", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setTriggerLasts))
+             ->addMethod("setInvert", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setInvert))
+             ->addMethod("setRadius", ExecutorLua1<ScriptTrigger, float>(&ScriptTrigger::setRadius))
+             ->addMethod("setScript", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setScript))
+             ->addMethod("setFunction", ExecutorLua1<ScriptTrigger, const std::string&>(&ScriptTrigger::setFunction))
+             ->addMethod("setDebugDraw", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setDebugDraw))
+             ->addMethod("setAddToScript", ExecutorLua1<ScriptTrigger, bool>(&ScriptTrigger::setAddToScript))
+             );
 
 
Index: trunk/src/world_entities/space_ships/cruizer.cc
===================================================================
--- trunk/src/world_entities/space_ships/cruizer.cc	(revision 9061)
+++ trunk/src/world_entities/space_ships/cruizer.cc	(revision 9061)
@@ -0,0 +1,372 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "cruizer.h"
+
+#include "weapons/weapon_manager.h"
+#include "weapons/test_gun.h"
+#include "weapons/turret.h"
+#include "weapons/cannon.h"
+
+#include "util/loading/factory.h"
+#include "key_mapper.h"
+#include "state.h"
+
+#include "graphics_engine.h"
+#include "dot_emitter.h"
+#include "sprite_particles.h"
+
+#include "debug.h"
+
+CREATE_FACTORY(Cruizer, CL_CRUIZER);
+
+/**
+ *  destructs the cruizer, deletes alocated memory
+ */
+Cruizer::~Cruizer ()
+{
+  this->setPlayer(NULL);
+}
+
+/**
+ * @brief loads a Cruizer information from a specified file.
+ * @param fileName the name of the File to load the cruizer from (absolute path)
+ */
+Cruizer::Cruizer(const std::string& fileName)
+{
+  this->init();
+  TiXmlDocument doc(fileName);
+
+  if(!doc.LoadFile())
+  {
+    PRINTF(2)("Loading file %s failed for Cruizer.\n", fileName.c_str());
+    return;
+  }
+
+  this->loadParams(doc.RootElement());
+}
+
+/**
+ * @brief creates a new Spaceship from Xml Data
+ * @param root the xml element containing spaceship data
+
+   @todo add more parameters to load
+*/
+Cruizer::Cruizer(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+
+
+  this->getWeaponManager().changeWeaponConfig(1);
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+
+  this->loadModel("models/ships/human_cruizer.obj", 0.05);
+
+}
+
+
+/**
+ * @brief initializes a Cruizer
+ */
+void Cruizer::init()
+{
+  //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
+  this->setClassID(CL_CRUIZER, "Cruizer");
+
+  this->setSupportedPlaymodes(Playable::Full3D);
+
+  bForward = bBackward = bLeft = bRight = bAscend = bDescend = false;
+  mouseSensitivity = 0.005;
+
+  this->rotorSpeed = 1000.0f;
+  this->rotorCycle = 0.0f;
+  this->cameraLook = 0.0f;
+  this->rotation = 0.0f;
+  this->acceleration = 10.0f;
+  this->airFriction = 2.0f;
+
+  this->setHealthMax(100);
+  this->setHealth(100);
+
+
+  // camera - issue
+  this->cameraNode.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+  this->cameraNode.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
+  //this->cameraNode.setParentMode(PNODE_ROTATE_MOVEMENT);
+  //this->cameraNode.setParent(this);
+
+
+  // PARTICLES
+  this->burstEmitter = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter->setParent(this);
+  this->burstEmitter->setRelCoor(0, -0.7, 0);
+  this->burstEmitter->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter->setName("Cruizer_Burst_emitter_Left");
+
+
+  this->burstSystem = new SpriteParticles(1000);
+  this->burstSystem->addEmitter(this->burstEmitter);
+  this->burstSystem->setName("SpaceShip_Burst_System");
+  ((SpriteParticles*)this->burstSystem)->setMaterialTexture("maps/radial-trans-noise.png");
+  this->burstSystem->setLifeSpan(1.0, .3);
+  this->burstSystem->setRadius(0.0, 1.5);
+  this->burstSystem->setRadius(0.05, 1.8);
+  this->burstSystem->setRadius(.5, .8);
+  this->burstSystem->setRadius(1.0, 0);
+  this->burstSystem->setColor(0.0, .7,.7,1,.5);
+  this->burstSystem->setColor(0.2, 0,0,0.8,.5);
+  this->burstSystem->setColor(0.5, .5,.5,.8,.3);
+  this->burstSystem->setColor(1.0, .8,.8,.8,.0);
+
+
+  //add events to the eventlist of the Playable
+  this->registerEvent(KeyMapper::PEV_FORWARD);
+  this->registerEvent(KeyMapper::PEV_BACKWARD);
+  this->registerEvent(KeyMapper::PEV_LEFT);
+  this->registerEvent(KeyMapper::PEV_RIGHT);
+  this->registerEvent(KeyMapper::PEV_UP);
+  this->registerEvent(KeyMapper::PEV_DOWN);
+  this->registerEvent(KeyMapper::PEV_FIRE1);
+  this->registerEvent(KeyMapper::PEV_NEXT_WEAPON);
+  this->registerEvent(KeyMapper::PEV_PREVIOUS_WEAPON);
+  this->registerEvent(EV_MOUSE_MOTION);
+
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+
+  // WEAPON_MANAGER configuration
+  this->getWeaponManager().setSlotCount(5);
+
+  this->getWeaponManager().setSlotPosition(2, Vector(-1.63, .809, -.003));
+  this->getWeaponManager().setSlotCapability(2, WTYPE_HEAVY);
+
+  /// TODO: THESE ARE TOO MUCH
+  this->getWeaponManager().setSlotPosition(3, Vector(-1.63, .678, -.652));
+  this->getWeaponManager().setSlotDirection(3, Quaternion(-24/180 * M_PI, Vector(1,0,0)));
+
+  this->getWeaponManager().setSlotPosition(4, Vector(-1.63, .678, .652));
+  this->getWeaponManager().setSlotDirection(4, Quaternion(24/180 * M_PI, Vector(1,0,0)));
+
+  this->cameraNode.setRelCoor(1,5,0);
+  this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
+  this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
+
+  registerVar( new SynchronizeableBool( &bForward, &bForward, "bForward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bBackward, &bBackward, "bBackward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bAscend, &bAscend, "bAscend", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bDescend, &bDescend, "bDescend", PERMISSION_OWNER ) );
+  //registerVar( new SynchronizeableQuaternion( &direction, &direction, "direction", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableFloat( &cameraLook, &cameraLook, "cameraLook", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableFloat( &rotation, &rotation, "rotation", PERMISSION_OWNER ) );
+}
+
+/**
+ * @brief loads the Settings of a Cruizer from an XML-element.
+ * @param root the XML-element to load the Spaceship's properties from
+ */
+void Cruizer::loadParams(const TiXmlElement* root)
+{
+  Playable::loadParams(root);
+}
+
+void Cruizer::setPlayDirection(const Quaternion& rot, float speed)
+{
+  this->direction = Quaternion (rot.getHeading(), Vector(0,1,0));
+}
+
+void Cruizer::enter()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( true);
+
+  if (State::getCameraNode != NULL)
+  {
+    State::getCameraNode()->setParentSoft(&this->cameraNode);
+    State::getCameraNode()->setRelCoorSoft(-10, 0,0);
+    State::getCameraTargetNode()->setParentSoft(&this->cameraNode);
+  }
+}
+
+void Cruizer::leave()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+  this->detachCamera();
+
+}
+
+
+/**
+ * @brief effect that occurs after the Cruizer is spawned
+*/
+void Cruizer::postSpawn ()
+{
+  //setCollision(new CollisionCluster(1.0, Vector(0,0,0)));
+}
+
+/**
+ * @brief the action occuring if the cruizer left the game
+*/
+void Cruizer::leftWorld ()
+{}
+
+/**
+ * @brief this function is called, when two entities collide
+ * @param entity: the world entity with whom it collides
+ *
+ * Implement behaviour like damage application or other miscellaneous collision stuff in this function
+ */
+void Cruizer::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  Playable::collidesWith(entity, location);
+}
+
+
+
+/**
+ * @brief the function called for each passing timeSnap
+ * @param time The timespan passed since last update
+*/
+void Cruizer::tick (float dt)
+{
+  //  this->debugNode(1);
+  Playable::tick(dt);
+
+  // spaceship controlled movement
+  this->movement(dt);
+  this->rotorCycle += this->rotorSpeed * dt;
+
+  // TRYING TO FIX PNode.
+  this->cameraNode.setAbsCoorSoft(this->getAbsCoor() + Vector(0.0f, 5.0f, 0.0f), 30.0f);
+  this->cameraNode.setRelDirSoft(this->getAbsDir(), 30.0f);
+}
+
+/**
+ * @brief calculate the velocity
+ * @param time the timeslice since the last frame
+*/
+void Cruizer::movement (float dt)
+{
+  Vector accel(0.0, 0.0, 0.0);
+
+  if( this->bForward )
+  {
+    accel += Vector(this->acceleration, 0, 0);
+  }
+
+  if( this->bBackward )
+  {
+    accel -= Vector(this->acceleration, 0, 0);
+  }
+  if( this->bLeft)
+  {
+    accel -= Vector(0, 0, this->acceleration);
+  }
+
+  if( this->bRight)
+  {
+    accel += Vector(0, 0, this->acceleration);
+  }
+
+  if (this->bAscend )
+  {
+    accel += Vector(0, this->acceleration, 0);
+  }
+  if (this->bDescend )
+  {
+    accel -= Vector(0, this->acceleration, 0);
+  }
+
+  switch(this->getPlaymode())
+  {
+    case Playable::Full3D:
+      {
+        Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
+
+        // this is the air friction (necessary for a smooth control)
+        Vector damping = (this->velocity * this->airFriction);
+
+
+        this->velocity += (accelerationDir - damping)* dt;
+        this->shiftCoor (this->velocity * dt);
+
+        // limit the maximum rotation speed.
+        if (this->rotation != 0.0f)
+        {
+          float maxRot = 10.0 * dt;
+          if (unlikely(this->rotation > maxRot)) this->rotation = maxRot;
+          if (unlikely(this->rotation < -maxRot)) this->rotation = -maxRot;
+          this->direction *= Quaternion(-M_PI/4.0*this->rotation, Vector(0,1,0));
+
+          this->rotation = 0.0f;
+        }
+
+        this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
+     }
+      break;
+
+    default:
+      PRINTF(2)("Playmode %s Not Implemented\n", Playable::playmodeToString(this->getPlaymode()).c_str());
+  }
+}
+
+
+void Cruizer::draw() const
+{
+  Vector tmpRot;
+  WorldEntity::draw();
+}
+
+/**
+ * @todo switch statement ??
+ */
+void Cruizer::process(const Event &event)
+{
+  Playable::process(event);
+
+  if( event.type == KeyMapper::PEV_LEFT)
+    this->bLeft = event.bPressed;
+  else if( event.type == KeyMapper::PEV_RIGHT)
+    this->bRight = event.bPressed;
+  else if( event.type == KeyMapper::PEV_UP)
+    this->bAscend = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == KeyMapper::PEV_DOWN)
+    this->bDescend = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == KeyMapper::PEV_FORWARD)
+    this->bForward = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == KeyMapper::PEV_BACKWARD)
+    this->bBackward = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == EV_MOUSE_MOTION)
+  {
+    float xMouse, yMouse;
+    xMouse = event.xRel*mouseSensitivity;
+    yMouse = event.yRel*mouseSensitivity;
+
+    // rotate the Player around the y-axis
+    this->rotation += xMouse;
+
+    this->cameraLook += yMouse;
+    // rotate the Camera around the z-axis
+    if (cameraLook > M_PI_4)
+      cameraLook = M_PI_4;
+    else if (cameraLook < -M_PI_4)
+      cameraLook = -M_PI_4;
+    //this->cameraNode.setRelDirSoft(this->direction,10);
+  }
+}
Index: trunk/src/world_entities/space_ships/cruizer.h
===================================================================
--- trunk/src/world_entities/space_ships/cruizer.h	(revision 9061)
+++ trunk/src/world_entities/space_ships/cruizer.h	(revision 9061)
@@ -0,0 +1,71 @@
+
+/*!
+ * @file cruizer.h
+ * Implements the Control of a Cruizer
+ */
+
+#ifndef _CRUIZER_H
+#define _CRUIZER_H
+
+#include "playable.h"
+
+// Forward Declaration
+class ParticleEmitter;
+class ParticleSystem;
+
+class Cruizer : public Playable
+{
+  public:
+    Cruizer(const std::string& fileName);
+    Cruizer(const TiXmlElement* root = NULL);
+    virtual ~Cruizer();
+
+    virtual void loadParams(const TiXmlElement* root);
+    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
+    virtual void enter();
+    virtual void leave();
+
+    virtual void postSpawn();
+    virtual void leftWorld();
+
+    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+    virtual void tick(float dt);
+    virtual void draw() const;
+
+    virtual void process(const Event &event);
+
+  private:
+    void init();
+    void movement(float dt);
+
+  private:
+    bool                  bForward;           //!< forward button pressed.
+    bool                  bBackward;          //!< backward button pressed.
+    bool                  bLeft;              //!< left button pressed.
+    bool                  bRight;             //!< right button pressed.
+    bool                  bAscend;            //!< ascend button pressed.
+    bool                  bDescend;           //!< descend button presses.
+
+    int                   yInvert;
+    float                 mouseSensitivity;   //!< the mouse sensitivity
+
+    PNode                 cameraNode;
+    float                 cameraLook;
+    float                 rotation;
+
+   // Vector                velocity;           //!< the velocity of the Cruizer.
+    Quaternion            direction;          //!< the direction of the Cruizer.
+    float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
+    float                 acceleration;       //!< the acceleration of the Cruizer.
+    float                 airFriction;        //!< AirFriction.
+
+    float                 rotorSpeed;         //!< the speed of the rotor.
+    float                 rotorCycle;         //!< The Cycle the rotor is in.
+
+    float                 airViscosity;
+
+    ParticleEmitter*      burstEmitter;
+    ParticleSystem*       burstSystem;
+};
+
+#endif /* _CRUIZERS_H */
Index: trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.cc	(revision 9059)
+++ trunk/src/world_entities/space_ships/space_ship.cc	(revision 9061)
@@ -55,5 +55,8 @@
 
 CREATE_FACTORY(SpaceShip, CL_SPACE_SHIP);
-
+#include "script_class.h"
+CREATE_SCRIPTABLE_CLASS(SpaceShip, CL_SPACE_SHIP,
+                        addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
+                       );
 
 /**
Index: trunk/src/world_entities/space_ships/spacecraft_2d.cc
===================================================================
--- trunk/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9061)
+++ trunk/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9061)
@@ -0,0 +1,408 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "spacecraft_2d.h"
+
+#include "weapons/weapon_manager.h"
+#include "weapons/test_gun.h"
+#include "weapons/turret.h"
+#include "weapons/cannon.h"
+
+#include "util/loading/factory.h"
+#include "key_mapper.h"
+#include "state.h"
+
+#include "graphics_engine.h"
+#include "dot_emitter.h"
+#include "sprite_particles.h"
+
+#include "debug.h"
+
+CREATE_FACTORY(Spacecraft2D, CL_SPACECRAFT_2D);
+
+
+/**
+ * @brief loads a Spacecraft2D information from a specified file.
+ * @param fileName the name of the File to load the spacecraft_2d from (absolute path)
+ */
+Spacecraft2D::Spacecraft2D(const std::string& fileName)
+{
+  this->init();
+  TiXmlDocument doc(fileName);
+
+  if(!doc.LoadFile())
+  {
+    PRINTF(2)("Loading file %s failed for Spacecraft2D.\n", fileName.c_str());
+    return;
+  }
+
+  this->loadParams(doc.RootElement());
+}
+
+/**
+ * @brief creates a new Spaceship from Xml Data
+ * @param root the xml element containing spaceship data
+
+   @todo add more parameters to load
+*/
+Spacecraft2D::Spacecraft2D(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+
+  //weapons:
+  Weapon* wpRight = new TestGun(0);
+  wpRight->setName("testGun Right");
+  Weapon* wpLeft = new TestGun(1);
+  wpLeft->setName("testGun Left");
+  //Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
+
+  //  cannon->setName("BFG");
+
+  this->addWeapon(wpLeft, 1, 0);
+  this->addWeapon(wpRight,1 ,1);
+  //this->addWeapon(cannon, 0, 2);
+
+  this->getWeaponManager().changeWeaponConfig(1);
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+}
+
+
+/**
+ *  destructs the spacecraft_2d, deletes alocated memory
+ */
+Spacecraft2D::~Spacecraft2D ()
+{
+  this->setPlayer(NULL);
+}
+
+/**
+ * @brief initializes a Spacecraft2D
+ */
+void Spacecraft2D::init()
+{
+  //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
+  this->setClassID(CL_SPACECRAFT_2D, "Spacecraft2D");
+
+  this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal);
+
+
+  bForward = bBackward = bLeft = bRight = false;
+  mouseSensitivity = 0.005;
+
+  this->cameraLook = 0.0f;
+  this->rotation = 0.0f;
+  this->acceleration = 10.0f;
+  this->altitude = 0.0f;
+
+  this->setHealthMax(100);
+  this->setHealth(100);
+
+
+  // camera - issue
+  this->travelNode.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
+  //this->cameraNode.setParentMode(PNODE_ROTATE_MOVEMENT);
+  //this->cameraNode.setParent(this);
+
+  // rotors
+  // PARTICLES
+  this->burstEmitter = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter->setParent(this);
+  this->burstEmitter->setRelCoor(0, -0.7, 0);
+  this->burstEmitter->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter->setName("Spacecraft2D_Burst_emitter_Left");
+
+
+  this->burstSystem = new SpriteParticles(1000);
+  this->burstSystem->addEmitter(this->burstEmitter);
+  this->burstSystem->setName("SpaceShip_Burst_System");
+  ((SpriteParticles*)this->burstSystem)->setMaterialTexture("maps/radial-trans-noise.png");
+  this->burstSystem->setLifeSpan(1.0, .3);
+  this->burstSystem->setRadius(0.0, 1.5);
+  this->burstSystem->setRadius(0.05, 1.8);
+  this->burstSystem->setRadius(.5, .8);
+  this->burstSystem->setRadius(1.0, 0);
+  this->burstSystem->setColor(0.0, .7,.7,1,.5);
+  this->burstSystem->setColor(0.2, 0,0,0.8,.5);
+  this->burstSystem->setColor(0.5, .5,.5,.8,.3);
+  this->burstSystem->setColor(1.0, .8,.8,.8,.0);
+
+
+  //add events to the eventlist of the Playable
+  this->registerEvent(KeyMapper::PEV_FORWARD);
+  this->registerEvent(KeyMapper::PEV_BACKWARD);
+  this->registerEvent(KeyMapper::PEV_LEFT);
+  this->registerEvent(KeyMapper::PEV_RIGHT);
+  this->registerEvent(KeyMapper::PEV_UP);
+  this->registerEvent(KeyMapper::PEV_DOWN);
+  this->registerEvent(KeyMapper::PEV_FIRE1);
+  this->registerEvent(KeyMapper::PEV_NEXT_WEAPON);
+  this->registerEvent(KeyMapper::PEV_PREVIOUS_WEAPON);
+  this->registerEvent(EV_MOUSE_MOTION);
+
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+
+  // WEAPON_MANAGER configuration
+  this->getWeaponManager().setSlotCount(5);
+
+  this->getWeaponManager().setSlotPosition(0, Vector(-0.28, 1.186, -2.750));
+  this->getWeaponManager().setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+  this->getWeaponManager().setSlotPosition(1, Vector(-0.28, 1.186, 2.750));
+  this->getWeaponManager().setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+  this->getWeaponManager().setSlotPosition(2, Vector(-1.63, .809, -.003));
+  this->getWeaponManager().setSlotCapability(2, WTYPE_HEAVY);
+
+  /// TODO: THESE ARE TOO MUCH
+  this->getWeaponManager().setSlotPosition(3, Vector(-1.63, .678, -.652));
+  this->getWeaponManager().setSlotDirection(3, Quaternion(-24/180 * M_PI, Vector(1,0,0)));
+
+  this->getWeaponManager().setSlotPosition(4, Vector(-1.63, .678, .652));
+  this->getWeaponManager().setSlotDirection(4, Quaternion(24/180 * M_PI, Vector(1,0,0)));
+
+  this->travelNode.setRelCoor(0,0,0);
+  //this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
+  //this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
+
+  registerVar( new SynchronizeableBool( &bForward, &bForward, "bForward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bBackward, &bBackward, "bBackward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
+  //registerVar( new SynchronizeableQuaternion( &direction, &direction, "direction", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableFloat( &cameraLook, &cameraLook, "cameraLook", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableFloat( &rotation, &rotation, "rotation", PERMISSION_OWNER ) );
+}
+
+/**
+ * @brief loads the Settings of a Spacecraft2D from an XML-element.
+ * @param root the XML-element to load the Spaceship's properties from
+ */
+void Spacecraft2D::loadParams(const TiXmlElement* root)
+{
+  Playable::loadParams(root);
+}
+
+void Spacecraft2D::setPlayDirection(const Quaternion& rot, float speed)
+{
+  this->direction = Quaternion (rot.getHeading(), Vector(0,1,0));
+}
+
+void Spacecraft2D::setTravelDirecton(const Quaternion& rot, float speed)
+{
+  this->setPlayDirection(rot, speed);
+}
+
+void Spacecraft2D::setTravelSpeed(float travelSpeed)
+{
+  this->travelSpeed = travelSpeed;
+}
+
+
+
+void Spacecraft2D::enter()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( true);
+
+  if (State::getCameraNode != NULL)
+  {
+    State::getCameraNode()->setParentSoft(&this->travelNode);
+    State::getCameraNode()->setRelCoorSoft(-10, 50,0);
+    State::getCameraTargetNode()->setParentSoft(&this->travelNode);
+  }
+}
+
+void Spacecraft2D::leave()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
+  this->detachCamera();
+
+}
+
+
+/**
+ * @brief effect that occurs after the Spacecraft2D is spawned
+*/
+void Spacecraft2D::postSpawn ()
+{
+  //setCollision(new CollisionCluster(1.0, Vector(0,0,0)));
+}
+
+/**
+ * @brief the action occuring if the spacecraft_2d left the game
+*/
+void Spacecraft2D::leftWorld ()
+{}
+
+/**
+ * @brief this function is called, when two entities collide
+ * @param entity: the world entity with whom it collides
+ *
+ * Implement behaviour like damage application or other miscellaneous collision stuff in this function
+ */
+void Spacecraft2D::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  Playable::collidesWith(entity, location);
+}
+
+
+
+/**
+ * @brief the function called for each passing timeSnap
+ * @param time The timespan passed since last update
+*/
+void Spacecraft2D::tick (float dt)
+{
+  //  this->debugNode(1);
+  Playable::tick(dt);
+
+  // spaceship controlled movement
+  this->movement(dt);
+
+  // TRYING TO FIX PNode.
+  //this->travelNode.setAbsCoorSoft(this->getAbsCoor() + Vector(0.0f, 5.0f, 0.0f), 30.0f);
+  //this->travelNode.setRelDirSoft(this->getAbsDir(), 30.0f);
+}
+
+/**
+ * @brief calculate the velocity
+ * @param time the timeslice since the last frame
+*/
+void Spacecraft2D::movement (float dt)
+{
+  Vector accel(0.0, 0.0, 0.0);
+
+  if( this->bForward )
+  {
+    accel += Vector(this->acceleration, 0, 0);
+  }
+
+  if( this->bBackward )
+  {
+    accel -= Vector(this->acceleration, 0, 0);
+  }
+  if( this->bLeft)
+  {
+    accel -= Vector(0, 0, this->acceleration);
+  }
+
+  if( this->bRight)
+  {
+    accel += Vector(0, 0, this->acceleration);
+  }
+
+
+  switch(this->getPlaymode())
+  {
+    case Playable::Full3D:
+      {
+        Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
+
+        // this is the air friction (necessary for a smooth control)
+
+        this->velocity += (accelerationDir)* dt;
+        this->shiftCoor (this->velocity * dt);
+
+        // limit the maximum rotation speed.
+        if (this->rotation != 0.0f)
+        {
+          float maxRot = 10.0 * dt;
+          if (unlikely(this->rotation > maxRot)) this->rotation = maxRot;
+          if (unlikely(this->rotation < -maxRot)) this->rotation = -maxRot;
+          this->direction *= Quaternion(-M_PI/4.0*this->rotation, Vector(0,1,0));
+
+          this->rotation = 0.0f;
+        }
+
+        this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
+
+      }
+      break;
+
+    case Playable::Horizontal:
+      {
+        accel.y = 0.0;
+        Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
+        accelerationDir.y = 0.0;
+
+        // this is the air friction (necessary for a smooth control)
+
+
+        this->velocity += (accelerationDir )* dt;
+        this->shiftCoor (this->velocity * dt);
+
+        // limit the maximum rotation speed.
+        if (this->rotation != 0.0f)
+        {
+          float maxRot = 10.0 * dt;
+          if (unlikely(this->rotation > 0.01 || this->rotation < 0.01)) this->rotation /=1.5;
+          this->direction *= Quaternion(-M_PI/4.0*this->rotation, Vector(0,1,0));
+
+          this->rotation = 0.0f;
+        }
+
+        this->setRelDirSoft(this->direction, 5);
+      }
+      break;
+
+    default:
+      PRINTF(2)("Playmode %s Not Implemented\n", Playable::playmodeToString(this->getPlaymode()).c_str());
+  }
+}
+
+
+void Spacecraft2D::draw() const
+{
+  WorldEntity::draw();
+}
+
+/**
+ * @todo switch statement ??
+ */
+void Spacecraft2D::process(const Event &event)
+{
+  Playable::process(event);
+
+  if( event.type == KeyMapper::PEV_LEFT)
+    this->bLeft = event.bPressed;
+  else if( event.type == KeyMapper::PEV_RIGHT)
+    this->bRight = event.bPressed;
+  else if( event.type == KeyMapper::PEV_FORWARD)
+    this->bForward = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == KeyMapper::PEV_BACKWARD)
+    this->bBackward = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == EV_MOUSE_MOTION)
+  {
+    float xMouse, yMouse;
+    xMouse = event.xRel*mouseSensitivity;
+    yMouse = event.yRel*mouseSensitivity;
+
+    // rotate the Player around the y-axis
+    if (this->getPlaymode() == Playable::Full3D)
+      this->rotation += xMouse;
+
+    this->cameraLook += yMouse;
+    // rotate the Camera around the z-axis
+    if (cameraLook > M_PI_4)
+      cameraLook = M_PI_4;
+    else if (cameraLook < -M_PI_4)
+      cameraLook = -M_PI_4;
+    //this->cameraNode.setRelDirSoft(this->direction,10);
+  }
+}
Index: trunk/src/world_entities/space_ships/spacecraft_2d.h
===================================================================
--- trunk/src/world_entities/space_ships/spacecraft_2d.h	(revision 9061)
+++ trunk/src/world_entities/space_ships/spacecraft_2d.h	(revision 9061)
@@ -0,0 +1,74 @@
+
+/*!
+ * @file spacecraft_2d.h
+ * Implements the Control of a Spacecraft2D
+ */
+
+#ifndef _SPACECRAFT_2D_H
+#define _SPACECRAFT_2D_H
+
+#include "playable.h"
+
+// Forward Declaration
+class ParticleEmitter;
+class ParticleSystem;
+
+class Spacecraft2D : public Playable
+{
+  public:
+    Spacecraft2D(const std::string& fileName);
+    Spacecraft2D(const TiXmlElement* root = NULL);
+    virtual ~Spacecraft2D();
+
+    virtual void loadParams(const TiXmlElement* root);
+    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
+    void setTravelDirecton(const Quaternion& rot, float speed = 0.0);
+    void setTravelSpeed(float travelSpeed);
+
+    virtual void enter();
+    virtual void leave();
+
+
+
+    virtual void postSpawn();
+    virtual void leftWorld();
+
+    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+    virtual void tick(float dt);
+    virtual void draw() const;
+
+    virtual void process(const Event &event);
+
+  private:
+    void init();
+    void movement(float dt);
+
+  private:
+    bool                  bForward;           //!< forward button pressed.
+    bool                  bBackward;          //!< backward button pressed.
+    bool                  bLeft;              //!< left button pressed.
+    bool                  bRight;             //!< right button pressed.
+
+    int                   yInvert;
+    float                 mouseSensitivity;   //!< the mouse sensitivity
+
+
+
+    PNode                 travelNode;
+    float                 travelSpeed;
+
+    float                 cameraLook;
+    float                 rotation;
+
+   // Vector                velocity;           //!< the velocity of the Spacecraft2D.
+    Quaternion            direction;          //!< the direction of the Spacecraft2D.
+    float                 acceleration;       //!< the acceleration of the Spacecraft2D.
+    float                 maxSpeed;           //!< The Maximal speed of the Spacecraft2D.
+
+    float                 altitude;           //!< The height in the Entity.
+
+    ParticleEmitter*      burstEmitter;
+    ParticleSystem*       burstSystem;
+};
+
+#endif /* _SPACECRAFT_2DS_H */
Index: trunk/src/world_entities/world_entity.cc
===================================================================
--- trunk/src/world_entities/world_entity.cc	(revision 9059)
+++ trunk/src/world_entities/world_entity.cc	(revision 9061)
@@ -82,5 +82,5 @@
 
   // registering default reactions:
-  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, CL_WORLD_ENTITY);
+  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, /*CL_WORLD_ENTITY*/ CL_PROJECTILE);
 
   this->toList(OM_NULL);
